Index: palm/trunk/SOURCE/timestep.f90
===================================================================
--- palm/trunk/SOURCE/timestep.f90	(revision 1483)
+++ palm/trunk/SOURCE/timestep.f90	(revision 1484)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! ------------------
-! 
+! Changes due to new module structure of the plant canopy model:
+!   calculations and parameters related to the plant canopy model removed
+!   (the limitation of the canopy drag, i.e. that the canopy drag itself should
+!   not change the sign of the velocity components, is now assured for in the
+!   calculation of the canopy tendency terms in subroutine plant_canopy_model) 
 ! 
 ! Former revisions:
@@ -76,5 +80,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  cdc, dzu, dzw, kh, km, lad_u, lad_v, lad_w, u, v, w
+        ONLY:  dzu, dzw, kh, km, u, v, w
 
     USE cloud_parameters,                                                      &
@@ -83,5 +87,5 @@
     USE control_parameters,                                                    &
         ONLY:  cfl_factor, coupling_mode, dt_3d, dt_fixed, dt_max,             &
-               galilei_transformation, old_dt, plant_canopy, message_string,   &
+               galilei_transformation, old_dt, message_string,                 &
                stop_dt, terminate_coupled, terminate_coupled_remote,           &
                timestep_reason, u_gtrans, use_ug_for_galilei_tr, v_gtrans
@@ -115,9 +119,4 @@
     REAL(wp) ::  dt_diff           !: 
     REAL(wp) ::  dt_diff_l         !: 
-    REAL(wp) ::  dt_plant_canopy   !: 
-    REAL(wp) ::  dt_plant_canopy_l !: 
-    REAL(wp) ::  dt_plant_canopy_u !: 
-    REAL(wp) ::  dt_plant_canopy_v !: 
-    REAL(wp) ::  dt_plant_canopy_w !: 
     REAL(wp) ::  dt_u              !: 
     REAL(wp) ::  dt_u_l            !: 
@@ -413,94 +412,8 @@
 
 !
-!--    Additional timestep criterion with plant canopies: 
-!--    it is not allowed to extract more than the available momentum
-       IF ( plant_canopy ) THEN
-
-          dt_plant_canopy_l = 0.0_wp
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO k = nzb+1, nzt
-                   dt_plant_canopy_u = cdc(k,j,i) * lad_u(k,j,i) *  &
-                                       SQRT(     u(k,j,i)**2     +  &
-                                             ( ( v(k,j,i-1)      +  &
-                                                 v(k,j,i)        +  &
-                                                 v(k,j+1,i)      +  &
-                                                 v(k,j+1,i-1) )     &
-                                               / 4.0_wp )**2     +  &
-                                             ( ( w(k-1,j,i-1)    +  &
-                                                 w(k-1,j,i)      +  &
-                                                 w(k,j,i-1)      +  &
-                                                 w(k,j,i) )         &
-                                                 / 4.0_wp )**2 ) 
-                   IF ( dt_plant_canopy_u > dt_plant_canopy_l ) THEN
-                      dt_plant_canopy_l = dt_plant_canopy_u  
-                   ENDIF
-                   dt_plant_canopy_v = cdc(k,j,i) * lad_v(k,j,i) *  &
-                                       SQRT( ( ( u(k,j-1,i)      +  &
-                                                 u(k,j-1,i+1)    +  &
-                                                 u(k,j,i)        +  &
-                                                 u(k,j,i+1) )       &
-                                               / 4.0_wp )**2     +  &
-                                                 v(k,j,i)**2     +  &
-                                             ( ( w(k-1,j-1,i)    +  &
-                                                 w(k-1,j,i)      +  &
-                                                 w(k,j-1,i)      +  &
-                                                 w(k,j,i) )         &
-                                                 / 4.0_wp )**2 ) 
-                   IF ( dt_plant_canopy_v > dt_plant_canopy_l ) THEN
-                      dt_plant_canopy_l = dt_plant_canopy_v
-                   ENDIF                   
-                   dt_plant_canopy_w = cdc(k,j,i) * lad_w(k,j,i) *  &
-                                       SQRT( ( ( u(k,j,i)        +  &
-                                                 u(k,j,i+1)      +  &
-                                                 u(k+1,j,i)      +  &
-                                                 u(k+1,j,i+1) )     &
-                                               / 4.0_wp )**2     +  &
-                                             ( ( v(k,j,i)        +  &
-                                                 v(k,j+1,i)      +  &
-                                                 v(k+1,j,i)      +  &
-                                                 v(k+1,j+1,i) )     &
-                                               / 4.0_wp )**2        +  &
-                                                 w(k,j,i)**2 )     
-                   IF ( dt_plant_canopy_w > dt_plant_canopy_l ) THEN
-                      dt_plant_canopy_l = dt_plant_canopy_w
-                   ENDIF
-                ENDDO
-             ENDDO
-          ENDDO 
-
-          IF ( dt_plant_canopy_l > 0.0_wp ) THEN
-!
-!--          Invert dt_plant_canopy_l and apply a security timestep factor 0.1
-             dt_plant_canopy_l = 0.1_wp / dt_plant_canopy_l
-          ELSE
-!
-!--          In case of inhomogeneous plant canopy, some processors may have no
-!--          canopy at all. Then use dt_max as dummy instead.
-             dt_plant_canopy_l = dt_max
-          ENDIF
-
-!
-!--       Determine the global minumum
-#if defined( __parallel )
-          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-          CALL MPI_ALLREDUCE( dt_plant_canopy_l, dt_plant_canopy, 1, MPI_REAL, &
-                              MPI_MIN, comm2d, ierr )
-#else
-          dt_plant_canopy = dt_plant_canopy_l
-#endif
-
-       ELSE
-!
-!--       Use dt_diff as dummy value to avoid extra IF branches further below
-          dt_plant_canopy = dt_diff
-
-       ENDIF
-
-!
 !--    The time step is the minimum of the 3-4 components and the diffusion time
 !--    step minus a reduction (cfl_factor) to be on the safe side.
 !--    The time step must not exceed the maximum allowed value.
-       dt_3d = cfl_factor * MIN( dt_diff, dt_plant_canopy, dt_u, dt_v, dt_w,   &
+       dt_3d = cfl_factor * MIN( dt_diff, dt_u, dt_v, dt_w,   &
                                  dt_precipitation )
        dt_3d = MIN( dt_3d, dt_max )
@@ -508,8 +421,6 @@
 !
 !--    Remember the restricting time step criterion for later output.
-       IF ( MIN( dt_u, dt_v, dt_w ) < MIN( dt_diff, dt_plant_canopy ) )  THEN
+       IF ( MIN( dt_u, dt_v, dt_w ) < dt_diff )  THEN
           timestep_reason = 'A'
-       ELSEIF ( dt_plant_canopy < dt_diff )  THEN
-          timestep_reason = 'C'
        ELSE
           timestep_reason = 'D'
@@ -528,5 +439,4 @@
                '&dt_w            = ', dt_w, ' s',                             &
                '&dt_diff         = ', dt_diff, ' s',                          &
-               '&dt_plant_canopy = ', dt_plant_canopy, ' s',                  &
                '&u_max           = ', u_max, ' m/s   k=', u_max_ijk(1),       &
                '  j=', u_max_ijk(2), '  i=', u_max_ijk(3),                    &
Index: palm/trunk/SOURCE/user_init_plant_canopy.f90
===================================================================
--- palm/trunk/SOURCE/user_init_plant_canopy.f90	(revision 1483)
+++ palm/trunk/SOURCE/user_init_plant_canopy.f90	(revision 1484)
@@ -20,5 +20,8 @@
 ! Current revisions:
 ! -----------------
-! 
+! Changes in the course of the canopy-model modularization:
+!   module plant_canopy_model_mod added,
+!   definition of array cdc (canopy drag coefficient) removed, since it is now
+!   defined purely as a single constant value (see module plant_canopy_model)
 ! 
 ! Former revisions:
@@ -57,4 +60,6 @@
     
     USE kinds
+
+    USE plant_canopy_model_mod
     
     USE user
@@ -62,6 +67,6 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) :: i   !: 
-    INTEGER(iwp) :: j   !: 
+    INTEGER(iwp) :: i   !: running index
+    INTEGER(iwp) :: j   !: running index
 
 !
@@ -69,5 +74,5 @@
 
 !
-!-- Set the 3D-arrays lad_s and cdc for user defined canopies
+!-- Set the 3D-array lad_s for user defined canopies
     SELECT CASE ( TRIM( canopy_mode ) )
 
@@ -78,19 +83,20 @@
        CASE ( 'user_defined_canopy_1' )
 !
-!--       Here the user can define his own topography. 
-!--       The following lines contain an example in that the 
-!--       plant canopy extends only over the second half of the 
-!--       model domain along x
+!--       Here the user can define his own forest topography. 
+!--       The following lines contain an example, where the plant canopy extends
+!--       only over the second half of the model domain along x.
+!--       Attention: DO-loops have to include the ghost points (nxlg-nxrg, 
+!--       nysg-nyng), because no exchange of ghost point information is intended,
+!--       in order to minimize communication between CPUs
 !          DO  i = nxlg, nxrg
 !             IF ( i >= INT(nx+1/2) ) THEN
 !                DO  j = nysg, nyng
 !                   lad_s(:,j,i) = lad(:)
-!                   cdc(:,j,i)   = drag_coefficient
 !                ENDDO
 !             ELSE
 !                lad_s(:,:,i) = 0.0_wp
-!                cdc(:,:,i)   = 0.0_wp
 !             ENDIF
 !          ENDDO 
+!
 !--       After definition, please
 !--       remove the following three lines!
Index: palm/trunk/SOURCE/write_var_list.f90
===================================================================
--- palm/trunk/SOURCE/write_var_list.f90	(revision 1483)
+++ palm/trunk/SOURCE/write_var_list.f90	(revision 1484)
@@ -20,5 +20,9 @@
 ! Current revisions:
 ! -----------------
-! 
+! Changes in the course of the canopy-model modularization:
+!   parameters alpha_lad, beta_lad, lai_beta added,
+!   module plant_canopy_model_mod added,
+!   drag_coefficient, leaf_surface_concentration and scalar_exchange_coefficient
+!   renamed to canopy_drag_coeff, leaf_surface_conc and leaf_scalar_exch_coeff
 !
 ! Former revisions:
@@ -104,5 +108,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  inflow_damping_factor, lad, mean_inflow_profiles, pt_init,      &
+        ONLY:  inflow_damping_factor, mean_inflow_profiles, pt_init,           &
                q_init, ref_state, sa_init, u_init, ug, v_init, vg
     
@@ -128,4 +132,11 @@
     
     USE pegrid
+
+    USE plant_canopy_model_mod,                                                &
+        ONLY:  alpha_lad, beta_lad, canopy_drag_coeff, canopy_mode, cthf, lad, &
+               lad_surface, lad_vertical_gradient, lad_vertical_gradient_level,&
+               lad_vertical_gradient_level_ind,                                &
+               lai_beta, leaf_scalar_exch_coeff, leaf_surface_conc, pch_index, &
+               plant_canopy
     
     USE statistics,                                                            &
@@ -163,4 +174,6 @@
     WRITE ( 14 )  'advected_distance_y           '
     WRITE ( 14 )  advected_distance_y
+    WRITE ( 14 )  'alpha_lad                     '
+    WRITE ( 14 )  alpha_lad
     WRITE ( 14 )  'alpha_surface                 '
     WRITE ( 14 )  alpha_surface
@@ -203,4 +216,6 @@
     WRITE ( 14 )  'bc_uv_t                       '
     WRITE ( 14 )  bc_uv_t
+    WRITE ( 14 )  'beta_lad                      '
+    WRITE ( 14 )  beta_lad
     WRITE ( 14 )  'bottom_salinityflux           '
     WRITE ( 14 )  bottom_salinityflux
@@ -217,4 +232,6 @@
     WRITE ( 14 )  'call_psolver_at_all_substeps  '
     WRITE ( 14 )  call_psolver_at_all_substeps
+    WRITE ( 14 )  'canopy_drag_coeff              '
+    WRITE ( 14 )  canopy_drag_coeff
     WRITE ( 14 )  'canopy_mode                   '
     WRITE ( 14 )  canopy_mode
@@ -275,6 +292,4 @@
     WRITE ( 14 )  'dpdxy                         '
     WRITE ( 14 )  dpdxy
-    WRITE ( 14 )  'drag_coefficient              '
-    WRITE ( 14 )  drag_coefficient
     WRITE ( 14 )  'drizzle                       '
     WRITE ( 14 )  drizzle
@@ -339,10 +354,14 @@
     WRITE ( 14 )  'lad_vertical_gradient_level_in'
     WRITE ( 14 )  lad_vertical_gradient_level_ind
+    WRITE ( 14 )  'lai_beta                      '
+    WRITE ( 14 )  lai_beta
     WRITE ( 14 )  'large_scale_forcing           '
     WRITE ( 14 )  large_scale_forcing
     WRITE ( 14 )  'large_scale_subsidence        '
     WRITE ( 14 )  large_scale_subsidence
-    WRITE ( 14 )  'leaf_surface_concentration    '
-    WRITE ( 14 )  leaf_surface_concentration
+    WRITE ( 14 )  'leaf_scalar_exch_coeff   '
+    WRITE ( 14 )  leaf_scalar_exch_coeff
+    WRITE ( 14 )  'leaf_surface_conc    '
+    WRITE ( 14 )  leaf_surface_conc
     WRITE ( 14 )  'limiter_sedimentation         '
     WRITE ( 14 )  limiter_sedimentation
@@ -475,6 +494,4 @@
     WRITE ( 14 )  'scalar_advec                  '
     WRITE ( 14 )  scalar_advec
-    WRITE ( 14 )  'scalar_exchange_coefficient   '
-    WRITE ( 14 )  scalar_exchange_coefficient
     WRITE ( 14 )  'simulated_time                '
     WRITE ( 14 )  simulated_time
